
# ====================================================================

	proc cToF {x}      { return [expr 32 + [expr $x * 9 / 5]] }

	proc mToFt {x}     { return [expr $x * 39.4 / 12] }

	proc trigTemp {alt tf} { return [expr $tf + [expr 5.4 * $alt /1000]] } 

	proc ixterp {x x0 x1 y0 y1}  {
			return [expr $y0+[expr $y1 - $y0]*[expr $x - $x0]/[expr $x1 - $x0]]
	}

# --------------------------------------------------------------------
# consume a file

	proc consume {fid color station}  {

		set flag -1
		set hght 0
		set temp 0

		while { [gets $fid line] >= 0}  {
			scan $line "%s %d %d %d" hdr pres hght temp

			if { [string match $hdr "Date:"] }  {
				set sndingDate $line
				displayRight $line
			}

			if { [string match $hdr "SFC"] }  {
				set flag 1
				set lev 0
			}

			if { $flag == 1 }  {
				set agl  [mToFt $hght]
				set tFar [cToF  $temp]

				set vAgl($lev) $agl
				set vTf($lev) $tFar

			#	puts [format "(%6d %3d) %6.0f %4.0f" $hght $temp $agl $tFar]

				if {$agl > 10000}  {
					set flag 0
				} else  {
					incr lev 1
				}

				if { [string match $hdr "TRP"] }  { set flag 0 }
			}
		}

	# dump data
		if { $flag != -1 }  {
			set yLast  -1
			set x1Last  0
			set x2Last  0

			set j      [expr $lev -1]
			set alt    [expr int($vAgl($j))]
			set maxAlt [expr $alt - [expr $alt % 500]]
			if {$maxAlt > 10000} {
				set maxAlt 10000
			}

			set j [expr $lev -2]
			for {set agl $maxAlt} {$agl > $vAgl(0)} {incr agl -500}  {
				for {} {$vAgl($j) > $agl} {incr j -1} {}
				set k [expr $j + 1]

				set tf   [ixterp $agl $vAgl($j) $vAgl($k) $vTf($j) $vTf($k)]
				set trig [trigTemp $agl $tf]

			#	plotText [format "%6d %6.1f %6.1f" $agl $tf $trig]

				if {$yLast > 0}  {
					plotLine $x1Last $yLast $tf   $agl $color
					plotLine $x2Last $yLast $trig $agl $color
				}

				set yLast  $agl
				set x1Last $tf
				set x2Last $trig
			}

			plotText "$station $sndingDate" $color
		} else  {
			plotText "$station   No-data" $color
		}
	}

# --------------------------------------------------------------------
	proc setTimestamp {}  {
		global currentTime
		set fid [open timestamp "w"]
		set currentTime [file mtime timestamp]
		close $fid
		file delete timestamp
	}

	proc getFileTimestamp {filename}  {
		set fid [open $filename "r"]
		set fileTimestamp [file mtime $filename]
		close $fid

		return $fileTimestamp
	}

# ====================================================================

		setTimestamp

		set _1hour   3600
		set _12hours [expr 12 * $_1hour]

# init screen
		set tLo -10.
		set tHi  90.

		screen    [expr $tHi - $tLo] $altMax
		setScale  $tLo $tHi 0 $altMax

		update idletasks
		after 100

# defines
		set server     "http://weather.unisys.com"
		set protoPage  "/upper_air/skew/skew_XXXX.txt"

		set nStations [llength $stations]

# process pages
		for {set i 0} {$i < $nStations} {incr i 1}  {
			set color   [lindex $colorList $i]
			set station [lindex $stations $i]
			regsub "XXXX" $protoPage  $station page

			set localFile "tmp/skew_$station.txt"

		# if local file > 12 hours old update from network
			if [file exists $localFile]  {
				set delta [expr $currentTime - [getFileTimestamp $localFile]]

				if {$delta > $_1hour}  {
					readUrl $server $page $localFile
				}
			} else  {
				readUrl $server $page $localFile
			}

		# reopen local file and process it
			set   fid [open $localFile r]
			consume $fid      $color $station
			close   $fid

		# 
			update idletasks
			after 100
		}
